/*
Program: elim
File: elim.h
Author: Marti Voros
*/

#ifndef ELIM_H_
#define ELIM_H_

#include<iostream>
#include<string>
#include<sstream>
#include<vector>

/*SYNAPS headers*/
#include "synaps/mpol.h"
#include "synaps/arithm/Zp.h"
#include "synaps/linalg/lapack.h"
#include "synaps/linalg/MatrDse.h"

#define MYVERSION 0.1
#define FIELD 2

/* Types definitions */
typedef Z<FIELD> coeff_t;
typedef MPol<coeff_t> mpol_t; // multivariate poly over coeff_t
typedef MatrDse<coeff_t,lapack::rep2d<coeff_t> > matrix_t;

using namespace std;

void load_eq(char * input, vector<mpol_t> &E);
void print_res(char * output);
void init_vars(mpol_t & mpol);
void linearize(vector<mpol_t> &eqs);
long uni_check(mpol_t::iterator mono);
unsigned long g2elim(matrix_t &A, vector<coeff_t> &B);

/* Support */
void usage ();
void arguments(int argc, char* argv[]);

#endif /*ELIM_H_*/
