/*
File: hash.h
Date: 05/03/2006
Author: Martin Voros
*/
#ifndef HASH_H_
#define HASH_H_

#define HT_DEF_SIZE 127

#include "elim.h"

typedef struct hash_cell {
	mpol_t::iterator it;
	unsigned long id;
	struct hash_cell * next;
} HASH_CELL;

void * xmalloc (size_t size);
void free_cell(HASH_CELL * p);
unsigned long hash_mono(mpol_t::iterator mono, unsigned long mod);
HASH_CELL ** ht_alloc(unsigned long size);
void ht_free(HASH_CELL * table[], unsigned long size);
unsigned long hash_lookup(mpol_t::iterator mono, HASH_CELL * list);
HASH_CELL * insert_mono(mpol_t::iterator it, HASH_CELL * list, vector<mpol_t::iterator> &vec, unsigned long id);

#endif  /* HASH_H_ */
