/*
File: common.c
Author: Martin Voros
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <ctype.h>

#include "common.h"

void *
xmalloc (size_t size)
{
	register void *value = malloc (size);
	if (value == 0) {
		fprintf(stderr,"Virtual memory exhausted!\n");
		exit(1);
	}
	return value;
}

void *
xrealloc (void *ptr, size_t size)
{
	register void *value = realloc (ptr, size);
	if (value == 0) {
		fprintf(stderr,"Virtual memory exhausted!\n");
		exit(1);
	}
	return value;
}

FILE *
xfopen(const char *filename, const char *opentype)
{
	FILE * file;

	errno = 0;
	file = fopen(filename,opentype);
	if (file != NULL) return file;
	else {
		if (*opentype == 'r') {
			fprintf(stderr,"I can't open file: %s",filename);
			perror(" ");
			return NULL;
		} else {
			perror("I can't create output file");
			exit(1);
		}
	}
}
