/*
 * File: comb.cpp
 * Author: Martin Voros
 */

#include <vector>
#include <iostream>

#include "comb.h"

/*
 * Factorial.
 */
unsigned long 
fact(unsigned int n)
{
	unsigned int i;
	unsigned long buf=1;
	
	if (n == 0) return 1;
	else {
		for (i=1;i<=n; i++) {
			buf=buf*i;	
		}
		return buf;
	}
}

/*
 * Bin. coef.
 */
unsigned long 
cn(unsigned int n, unsigned int k)
{
	unsigned int i;
	unsigned long buf=n;

	for (i=0; i<k-1; i++) {
		buf=buf*(n-i-1);
	}
	if (k == 0) return buf;
		else return (buf / fact(k));
}

/*
 * Get next combination 
 */ 
void
comb_next(unsigned int n, unsigned int k, Comb &a )
{
//	cout << "Pred: " << endl;
//	for (int j=0; j<a.size(); j++)
//			cout << a.at(j) << " ";

	unsigned int i = k - 1;
	while (a.at(i) == n - k + i) {
		i--;
	}

//	cout << "Zvysime o 1 pre i=" << i << endl;
	a.at(i)++;
	for (unsigned int j=i + 1; j < k; j++) {
//		cout << "nic" << endl;
		a.at(j) = a.at(i) + j - i;
	}
//	cout << "Po procese: " << endl;
//	for (int j=0; j<a.size(); j++)
//			cout << a.at(j) << " ";
//	cout << endl;
}


/*
 * Get next combination with repetition.
 */ 
void
combr_next(unsigned int index, unsigned int range, Comb &a )
{

	if (a.at(index) < range) {
		a.at(index)++;
	} else {
		if (index < (a.size() -1) ) {
			combr_next(index + 1, range, a);
			a.at(index)=a.at(index+1);
		}
	}
}

/*
 * Generate all combinations.
 */ 
void
gen_comb(unsigned int var, unsigned int degree, ListComb &list)
{
	unsigned long j;
	unsigned int index = 0;
	vector<int> c(degree);
	
	for (int k=0; k<degree; k++)
		c.at(k)=k;

	j=cn(var, degree);
	list.push_back(c);
	for (int k=0; k<j-1; k++) {
		comb_next(var, degree, c); // get next combination
		list.push_back(c);	
	}
}

/*
 * Generate all combinations with rep.
 */ 
void
gen_comb_rep(unsigned int var, unsigned int degree, ListComb &list)
{
	unsigned long j;
	unsigned int index = 0;
	vector<int> c(degree);
	
	j=cn(var + degree - 1,degree);
	for (int k=0; k<j; k++) {
		list.push_back(c);			
		combr_next(0, var-1, c); // get next combination
	}
}

bool 
contain_comb(int val, Comb &a)
{
	for (int i=0; i<a.size(); i++)
		if (a.at(i) == val) {
			return true;
		}
	return false;
}


/*
 * Removes all comb. from L with variable var_index
 */ 
void
remove_comb(ListComb &L, long var_index)
{
/*	cout << "COMBS pred" << endl;
	for (int i=0; i<L.size(); i++) {
		for (int j=0; j<L.at(i).size(); j++)
			cout << L.at(i).at(j) << " ";
		cout << endl;
	}
	cout << "remove " << var_index << endl;
*/	
	for(vector<Comb>::iterator it=L.begin(); it !=L.end(); it++) {
		if (contain_comb(var_index, *it)) { 
			L.erase(it);
			it--;
		}	
	}
/*
	// testing
	cout << "COMBS" << endl;
	for (int i=0; i<L.size(); i++) {
		for (int j=0; j<L.at(i).size(); j++)
			cout << L.at(i).at(j) << " ";
		cout << endl;
	}*/
}
